optic-distribution-system2/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index');

Auth::routes();
//Route User
Route::get('/User/datatable', 'UserController@datatable')->middleware('auth');

//Route Category
Route::get('/Category/datatable', 'CategoryController@datatable')->middleware('auth');
Route::patch('/Category/json', 'CategoryController@getItemJson')->middleware('auth');
Route::get('/Category/jsonSelect', 'CategoryController@getItemJsonSelect2')->middleware('auth');

//Route SubCategory
Route::get('/SubCategory/datatable/{id}', 'SubCategoryController@datatable')->middleware('auth');
Route::patch('/SubCategory/json', 'SubCategoryController@getItemJson')->middleware('auth');
Route::get('/SubCategory/jsonSelect', 'SubCategoryController@getItemJsonSelect2')->middleware('auth');

//Route Optic
Route::get('/Optic/datatable', 'OpticController@datatable')->middleware('auth');
Route::patch('/Optic/json', 'OpticController@getOpticJson')->middleware('auth');

//Route Item
Route::get('/Item/datatable', 'ItemController@datatable')->middleware('auth');
Route::patch('/Item/json', 'ItemController@getItemJson')->middleware('auth');
Route::patch('/Item/jsonitemWithStock', 'ItemController@getItemWithStockJson')->middleware('auth');
Route::get('/Item/jsonSelect', 'ItemController@getItemJsonSelect2')->middleware('auth');

//Route Order
Route::get('/Order/datatable', 'SalesController@datatable')->middleware('auth');
Route::get('/Order/view/{id}', 'SalesController@view')->middleware('auth');
Route::get('/Order/edit/{id}', 'SalesController@edit')->middleware('auth');
Route::get('/Order/retur/{id}', 'SalesController@retur')->middleware('auth');
Route::post('/Order/retur/{id}', 'SalesController@prosesRetur')->middleware('auth');

Route::post('/Order/editSales/{id}', 'SalesController@updateSales')->middleware('auth');


Route::get('/Category/SubCategory/{id}', 'CategoryController@ajax_subcategory')->middleware('auth');
Route::get('/ItemStock/datatable', 'ItemStockController@datatable')->middleware('auth');
Route::get('/Print/{id}', 'PrintController@index')->middleware('auth');
Route::get('/Print/{id}/{id_payment}', 'PrintController@payment')->middleware('auth');
Route::get('/Print/ReturDistributor/{id}', 'PrintController@ReturDistributor')->middleware('auth');


Route::resource('User', 'UserController')->middleware('auth');
Route::resource('Category', 'CategoryController')->middleware('auth');
Route::resource('SubCategory', 'SubCategoryController')->middleware('auth');
Route::resource('Optic', 'OpticController')->middleware('auth');
Route::resource('Item', 'ItemController')->middleware('auth');
//Route::resource('Payment', 'PaymentController')->middleware('auth');
Route::get('Payment/{id}', ["as" => "Payment.index", "uses" => "PaymentController@index"])->middleware('auth');
Route::get('Payment/{id}/datatable', 'PaymentController@datatable')->middleware('auth');
Route::get('Payment/{id}/create', 'PaymentController@create')->middleware('auth');
Route::post('Payment', 'PaymentController@store')->middleware('auth');

Route::resource('Stock', 'ItemStockController')->middleware('auth');
Route::resource('Order', 'SalesController')->middleware('auth');

Route::get('/home', 'HomeController@index')->name('home')->middleware('auth');


Route::get('/Item/test', 'ItemController@test')->middleware('auth');

Route::get('/Stock/updateItemStock/{id}', 'ItemStockController@newStock')->middleware('auth');
Route::get('/Stock/detail/{id}', 'ItemStockController@detailStock')->middleware('auth');
Route::get('/receiveItemStock', 'ItemStockController@receiveStock')->middleware('auth');
Route::get('/Stock/create', 'ItemStockController@receiveStock')->middleware('auth');


Route::get('/Stock/newItemStock/{id}', 'ItemStockController@newStock')->middleware('auth');
Route::get('/receiveItemStock', 'ItemStockController@receiveStock')->middleware('auth');

// report controller
Route::get('/Report/inventoryDatatable', 'ReportController@inventoryDatatable')->middleware('auth');
Route::get('/Report/inventoryLowDatatable', 'ReportController@inventoryLowDatatable')->middleware('auth');
Route::get('/Report/expiryDatatable', 'ReportController@expiryDatatable')->middleware('auth');
Route::get('/Report/salesDatatable', 'ReportController@salesDatatable');
Route::post('/Report/salesDatatable', 'ReportController@salesDatatable');
Route::get('/Report/stokChartJson', 'ReportController@inventoryChartJSON');
Route::get('/Report/salesChartByItemJSON', 'ReportController@salesChartByItemJSON');
Route::get('/Report/salesChartByRevenueJSON', 'ReportController@salesChartByRevenueJSON');
Route::get('/Report/summaryJson', 'ReportController@summaryJson');


Route::get('/Report/inventory', 'ReportController@inventory')->middleware('auth');
Route::get('/Report/inventoryLow', 'ReportController@inventoryLow')->middleware('auth');
Route::get('/Report/sales', 'ReportController@sales')->middleware('auth');
Route::get('/Report/expiry', 'ReportController@expiry')->middleware('auth');

Route::get('/Retur', 'ReturController@index')->middleware('auth');
Route::get('/Retur/Client', 'ReturController@indexClient')->middleware('auth');
Route::get('/Retur/Client/datatable', 'ReturController@datatableClient')->middleware('auth');
Route::get('/Retur/Client/{id}', 'ReturController@viewClient')->middleware('auth');
Route::delete('/Retur/Client/delete/{id}', 'ReturController@destroyClient')->middleware('auth');

Route::get('/Retur/datatable', 'ReturController@datatable')->middleware('auth');
Route::get('/ReturDistributor/create', 'ReturController@createDistributor')->middleware('auth');
Route::post('/ReturDistributor/create', 'ReturController@storeDistributor')->middleware('auth');
Route::get('/ReturDistributor/view/{id}', 'ReturController@viewDistributor')->middleware('auth');
Route::get('/ReturDistributor/edit/{id}', 'ReturController@editDistributor')->middleware('auth');
Route::post('/ReturDistributor/edit/{id}', 'ReturController@updateDistributor')->middleware('auth');
Route::delete('/ReturDistributor/delete/{id}', 'ReturController@destroyDistributor')->middleware('auth');

Route::get('/Report/receivings', 'ReportController@receivings')->middleware('auth');



Route::get('/OpticList/datatable', 'BillingController@datatable')->middleware('auth');
Route::resource('Billing', 'BillingController')->middleware('auth');
Route::patch('/billing/json', 'BillingController@getOpticJson')->middleware('auth');

optic-distribution-system2/app/Payment.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Payment extends Model
{
  protected $primaryKey = 'id';
  protected $table = 'sales_payment';

  public function getMetodePembayaranAttribute()
  {
      if($this->metode == 1){
        return "Cash";
      }else {
        return "Transfer";
      }
  }
}

optic-distribution-system2/app/Sale.php
<?php

namespace App;


use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
class Sale extends Model
{
use SoftDeletes;
  public function optic(){
      return $this->belongsTo('App\Optic','optic_id','id');
    }

    public function items()
    {
        return $this->belongsToMany('App\Item', 'sales_items',
          'sale_id', 'item_id')->withPivot('jumlah', 'harga_jual','diskon');
    }

    public function getStaffNameAttribute(){
      $user = User::find($this->user_id)->first();

      return $user;
    }

    public function getTotalTerbayarAttribute(){
      $retVal = Payment::where('sale_id','=',$this->id)->sum('jumlah');
      return $retVal;
    }

    public function getIdStringAttribute()
    {
        $temp = "".$this->id;
        $retVal = "";
        for($i=0;$i<(12 - strlen($temp));$i++){
          $retVal = $retVal."0";
        }
        $retVal = $retVal."". $temp;

        return $retVal;
    }

    public function getJenisStringAttribute()
    {
        if($this->jenis_pembayaran == "1"){
          return "Sekali Bayar";
        }else {
          return "Bertahap";
        }
    }

    public function getStatusPembayaranAttribute(){
      $terbayar = $this->getTotalTerbayarAttribute();

      if($terbayar!=$this->total)
        return "Pending";
      else
        return "Lunas";
    }

    protected $dates = ['deleted_at'];
}

optic-distribution-system2/app/Http/Controllers/PaymentController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DataTables;
use App\Sale;
use App\Optic;
use Auth;
use App\Payment;
use Redirect;
use Validator;
class PaymentController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */

     public function datatable($id){
         $model = Payment::query();

         return DataTables::eloquent($model)
                 ->addColumn('action', function(Payment $payment) {
                     $retVal = '
                               <a data-toggle="confirmation" data-btn-ok-class="btn btn-sm btn-success" data-btn-cancel-class="btn btn-danger btn-sm" data-id="'.$payment->id.'" data-original-title="Hapus Data User?" data-singleton="true" type="button" class="btn red btn-outline" >delete</a>';
                     return $retVal;
                 })

                 ->rawColumns(['action'])
                 ->toJson();
     }

    public function index(Request $request,$id)
    {

      $temp = "".$id;
      $retVal = "";
      for($i=0;$i<(12 - strlen($temp));$i++){
        $retVal = $retVal."0";
      }
      $retVal = $retVal."". $temp;

      $sale = Sale::find($id)->first();
      $maxPayment = Payment::where('sale_id',$id)->max('id');

      return view('payment.index')->with('id_string',$retVal)
                                    ->with('id',$id)
                                    ->with('sale',$sale)
                                    ->with('maxPayment',$maxPayment)
                                    ->with('successMsg',$request->input('successMsg'))
                                    ;
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create($id)
    {
      $payment = new Payment;
      $sale = Sale::find($id)->first();
      return view('payment.create', ['model'=>$payment,'sale_id'=>$id,'sale'=>$sale]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
      $validator = Validator::make($request->all(), [
        'jumlah'      => 'required|max:15'
      ]);

      $sale = Sale::find($request->sale_id);
      if ($validator->fails() || ($request->jenis == 1 && $request->jumlah != $sale->total))
      {
          $validator->errors()->add('jumlah', 'Jumlah tidak sesuai dengan tagihan');
          return Redirect::back()->withErrors($validator);
      }


      $payment = new Payment;

      $payment->metode   = $request->metode;
      $payment->jumlah   = $request->jumlah;
      $payment->sale_id  = $request->sale_id;
      $payment->user_id  = Auth::id();

      $payment->save();

      $optic = Optic::find($sale->optic->id);
      $optic->sisa_plafon += $request->jumlah;
      $optic->save();

      $maxPayment = Payment::where('sale_id',$request->sale_id)->max('id');
      $request->session()->put('successMsg', 'Payment created successfully');
      return redirect()->route('Payment.index',['id' => $request->sale_id])
                        ->with('successMsg','Payment created successfully');
      //return redirect()->action('PaymentController@index', ['id' => $request->sale_id,'maxPayment'=>$maxPayment]);

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

optic-distribution-system2/resources/views/payment/create.blade.php
@extends('layouts.app')

@section('content')

<div class="page-content-wrapper">
  <div class="page-content-wrapper">
      <div class="page-content">
          <div class="page-bar">
              <ul class="page-breadcrumb">
                  <li>
                      <i class="icon-home"></i>
                      <a href="{{ url("Payment") }}">Manage Payment</a>
                      <i class="fa fa-angle-right"></i>
                  </li>
                  <li>
                      <span>New Payment</span>
                  </li>
              </ul>
          </div>
          <!-- BODY CONTENT -->
          <div class="row">
              <div class="col-md-12">
              <div class="portlet light ">
                <div class="portlet-title">
                    <div class="caption">
                        <i class="icon-plus"></i>
                        <span class="caption-subject bold uppercase"> Create New Payment Invoice </span>
                    </div>
                    <div class="actions">
                        <a class="btn btn-circle btn-icon-only btn-default fullscreen" href="javascript:;" data-original-title="" title=""> </a>
                    </div>
                </div>
                  <div class="portlet-body form">
                    <div class="form-body">
                    {{ Form::model($model, ['action' => 'PaymentController@store','class'=>"form-horizontal"]) }}

                    <div class="form-group ">
                      <label for="nama" class="col-sm-3 control-label">Metode Pembayaran</label>
                      <div class="col-sm-8">
                        <select class="form-control select2" data-placeholder="Choose Optic" id="metode" name="metode" tabindex="1">
                          <option value="1">Cash</option>
                          <option value="2">Transfer</option>
                        </select>
                      </div>
                    </div>
                    <input type="hidden" name="jenis" id="jenis" value="{{$sale->jenis_pembayaran}}">
                    <input placeholder="Input Jumlah" name="sale_id" type="text" value="{{$sale_id}}" id="sale_id" hidden />

                    <?php
                       $item = array(
                                array("text", "jumlah", "Jumlah" ,"col-sm-3","col-sm-8",'0')
                              );
                    ?>

                    {!!NPMForm::FormGenerate($errors,$item)!!}

                    </div>
                    <div class="form-actions">
                        <div class="row">
                            <div class="col-md-offset-3 col-md-9">
                                <button type="submit" class="btn green">Submit</button>
                                <button type="button" class="btn default">Cancel</button>
                            </div>
                        </div>
                    </div>

                    {{ Form::close() }}
                  </div>
                  </div>
              </div>

          </div>
          <!-- END BODY CONTENT -->

      </div>
      <!-- END CONTENT -->
  </div>
</div>

@endsection

optic-distribution-system2/resources/views/payment/edit.blade.php
@extends('layouts.app')

@section('content')

<div class="page-content-wrapper">
  <div class="page-content-wrapper">

      <div class="page-content">
          <div class="page-bar">
              <ul class="page-breadcrumb">
                  <li>
                      <i class="icon-home"></i>
                      <a href="{{ url("Optic") }}">Manage Optic</a>
                      <i class="fa fa-angle-right"></i>
                  </li>

                  <li>
                      <span>Edit Optic</span>
                  </li>
              </ul>
          </div>
          <!-- BODY CONTENT -->
          <div class="row">
              <div class="col-md-12">
              <div class="portlet light ">
                <div class="portlet-title">
                    <div class="caption">
                        <i class="icon-plus"></i>
                        <span class="caption-subject bold uppercase"> Create New Optic</span>
                    </div>
                    <div class="actions">
                        <a class="btn btn-circle btn-icon-only btn-default fullscreen" href="javascript:;" data-original-title="" title=""> </a>
                    </div>
                </div>
                  <div class="portlet-body form">
                    <div class="form-body">
                    {!! Form::model($optic, ['method' => 'PATCH','route' => ['Optic.update', $optic->id],'class'=>"form-horizontal"]) !!}

                    <?php

                       $item = array(
                                array("text", "nama", "Nama" ,"col-sm-3","col-sm-8",$optic->nama),
                                array("text", "alamat","Alamat", "col-sm-3","col-sm-8",$optic->alamat),
                                array("text", "telepon","telepon", "col-sm-3","col-sm-8",$optic->telepon),
                              );
                    ?>

                    {!!NPMForm::FormGenerate($errors,$item)!!}

                    </div>
                    <div class="form-actions">
                        <div class="row">
                            <div class="col-md-offset-3 col-md-9">
                                <button type="submit" class="btn green">Submit</button>
                                <button type="button" class="btn default">Cancel</button>
                            </div>
                        </div>
                    </div>

                    {{ Form::close() }}
                  </div>
                  </div>
              </div>

          </div>
          <!-- END BODY CONTENT -->

      </div>
      <!-- END CONTENT -->
  </div>
</div>

@endsection

optic-distribution-system2/resources/views/payment/index.blade.php
@extends('layouts.app')

@component('components.toastrNotif')
@endcomponent

@component('components.datatablePlugin')
@endcomponent

@section('content')

<div class="page-content-wrapper">

    <div class="page-content">
        <h2 class="page-title"> List Payment
            <small>detail & manage payment</small>
        </h2>

        <!-- BODY CONTENT -->
        <div class="row">
            <div class="col-md-12">
              <?php if(session('errMessage')) {?>
                  <div class="alert alert-danger">
                    {{session('errMessage')}}
                  </div>
              <?php } ?>

              <div class="portlet light bordered">
                  <div class="portlet-title">
                      <div class="caption">
                          <i class="icon-equalizer font-green-haze"></i>
                          <span class="caption-subject font-green-haze bold uppercase">Invoice Info</span>
                          @if($sale->total!=$sale->total_terbayar)
                            <span class="label label-danger"> Pending </span>
                          @endif
                          @if($sale->total==$sale->total_terbayar)
                            <span class="label label-success"> Lunas </span>
                          @endif

                      </div>
                      <div class="tools">
                          <a href="" class="collapse" data-original-title="" title=""> </a>
                          <a href="#portlet-config" data-toggle="modal" class="config" data-original-title="" title=""> </a>
                          <a href="" class="reload" data-original-title="" title=""> </a>
                          <a href="" class="remove" data-original-title="" title=""> </a>
                      </div>
                  </div>
                  <div class="portlet-body form">
                      <!-- BEGIN FORM-->
                      <form class="form-horizontal" role="form">
                          <div class="form-body">
                              <div class="row">
                                  <div class="col-md-6">
                                      <div class="form-group">
                                          <label class="control-label col-md-3">Invoice Id:</label>
                                          <div class="col-md-9">
                                              <p class="form-control-static"> {{$id_string}} </p>
                                          </div>
                                      </div>
                                  </div>
                                  <!--/span-->
                                  <div class="col-md-6">
                                      <div class="form-group">
                                          <label class="control-label col-md-3">Optik:</label>
                                          <div class="col-md-9">
                                              <p class="form-control-static"> {{$sale->optic->nama}} </p>
                                          </div>
                                      </div>
                                  </div>
                                  <!--/span-->
                              </div>
                              <!--/row-->
                              <div class="row">
                                  <div class="col-md-6">
                                      <div class="form-group">
                                          <label class="control-label col-md-3">Sisa Tagihan:</label>
                                          <div class="col-md-9">
                                              <p class="form-control-static">Rp {{number_format($sale->total,0)}} </p>
                                          </div>
                                      </div>
                                  </div>
                                  <!--/span-->
                                  <div class="col-md-6">
                                      <div class="form-group">
                                          <label class="control-label col-md-3">Alamat Optik:</label>
                                          <div class="col-md-9">
                                              <p class="form-control-static"> {{$sale->optic->alamat}} </p>
                                          </div>
                                      </div>
                                  </div>
                                  <!--/span-->
                              </div>
                              <div class="row">
                                  <div class="col-md-6">
                                      <div class="form-group">
                                          <label class="control-label col-md-3">Terbayar:</label>
                                          <div class="col-md-9">
                                              <p class="form-control-static">Rp {{number_format($sale->total_terbayar,0)}} </p>
                                          </div>
                                      </div>
                                  </div>
                                  <!--/span-->
                                  <div class="col-md-6">
                                      <div class="form-group">
                                          <label class="control-label col-md-3">Jatuh Tempo:</label>
                                          <div class="col-md-9">
                                              <p class="form-control-static"> {{$sale->jatuh_tempo}} </p>
                                          </div>
                                      </div>
                                  </div>
                                  <!--/span-->
                              </div>
                              <div class="row">
                                  <div class="col-md-6">
                                      <div class="form-group">
                                          <label class="control-label col-md-3">Metode:</label>
                                          <div class="col-md-9">
                                              <p class="form-control-static">{{$sale->jenis_string}} </p>
                                          </div>
                                      </div>
                                  </div>
                              </div>

                          </div>
                      </form>
                      <!-- END FORM-->
                  </div>
              </div>

              <div class="portlet light ">
                  <div class="portlet-title">
                      <a href="{{url('/Payment')}}/{{$id}}/create" type="button" class="btn blue btn-outline">New Payment</a>
                  </div>
                  <div class="portlet-body">
                    @component('components.npmDatatable')
                      @slot('idTable')
                        payments
                      @endslot
                      <thead>
                      <tr>
                        <th>
                          Tanggal
                        </th>
                        <th>
                          Metode Pembayaran
                        </th>
                        <th>
                          Jumlah
                        </th>
                        <th>
                          PIC
                        </th>
                        <th>
                          Action
                        </th>
                      </tr>
                      </thead>
                    @endcomponent
                  </div>
                </div>
            </div>

        </div>
        <!-- END BODY CONTENT -->

    </div>
    <!-- END CONTENT -->
</div>

@endsection

@push('scripts')
<script>

$(function() {
    @if(session('successMsg'))
      toastr.success("{{session('successMsg')}}", "Success")
      var win = window.open('{{url("Print")}}/{{$id}}/{{$maxPayment}}', '_blank');
    @endif

    var table = $('#payments').DataTable({
        processing: true,
        serverSide: true,
        ajax: '{{ url("Payment") }}/{{$id}}/datatable',
        columns: [
            { data: 'created_at', name: 'created_at' },
            { data: 'metode', name: 'metode' },
            { data: 'jumlah', name: 'jumlah' },
            { data: 'user_id', name: 'user_id' },
            { data: 'action', name: 'action',Sortable: "false"}
        ],
        columnDefs: [
          { className: "dt-body-center", "targets": [ 2,3] },
          { width: "70px", targets: [2] },
          { width: "150px",orderable: false, targets: [3] }
        ],
        fnDrawCallback: function (oSettings) {

              $("[data-toggle='confirmation']").confirmation({
                singleton: true,
                onConfirm:function(){
                  var myElement = $(this).closest('.popover').prev();
                  var id        = myElement.context.getAttribute('data-id');

                  $.ajax({
                      url: '{{url("Optic")}}/'+id,
                      type: 'DELETE',
                      data: {_token: '{{csrf_token()}}'},
                      success: function(result) {
                        table.ajax.reload();

                        toastr[success]("Payment Berhasil dihapus", "Success")

                        toastr.options = {
                          "closeButton": false,
                          "debug": false,
                          "newestOnTop": false,
                          "progressBar": false,
                          "positionClass": "toast-top-right",
                          "preventDuplicates": false,
                          "onclick": null,
                          "showDuration": "300",
                          "hideDuration": "1000",
                          "timeOut": "5000",
                          "extendedTimeOut": "1000",
                          "showEasing": "swing",
                          "hideEasing": "linear",
                          "showMethod": "fadeIn",
                          "hideMethod": "fadeOut"
                        }
                      }
                  });

                }
              });
            }
    });
});


</script>

<script src="{{asset("assets/global/plugins/bootstrap-confirmation/bootstrap-confirmation.min.js")}}" type="text/javascript"></script>
<script src="{{asset("assets/pages/scripts/ui-confirmations.min.js")}}" type="text/javascript"></script>

@endpush